"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.validateDeleteUpdatesByDeviceIdOutput = exports.validateDeleteUpdatesByDeviceIdInput = exports.validatePatchUpdatesByDeviceIdOutput = exports.validatePatchUpdatesByDeviceIdInput = exports.validateGetUpdatesByDeviceIdOutput = exports.validateGetUpdatesByDeviceIdInput = exports.validatePostUpdatesOutput = exports.validatePostUpdatesInput = exports.validateGetUpdatesOutput = exports.validateGetUpdatesInput = void 0;
const basicValidation_1 = require("./basicValidation");
/**
 * This function validates the inputs of a GET request on /updates
 */
function validateGetUpdatesInput() {
    return true;
}
exports.validateGetUpdatesInput = validateGetUpdatesInput;
/**
 * This function validates the outputs to a GET request on /updates
 */
function validateGetUpdatesOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validateGetUpdatesResponse200)(response.body)) {
            validateGetUpdatesOutput.errors = basicValidation_1.validateGetUpdatesResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetUpdatesOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetUpdatesOutput = validateGetUpdatesOutput;
/**
 * This function validates the inputs of a POST request on /updates
 */
function validatePostUpdatesInput(body) {
    if (!(0, basicValidation_1.validatePostUpdatesRequestBody)(body)) {
        validatePostUpdatesInput.errors = basicValidation_1.validatePostUpdatesRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePostUpdatesInput = validatePostUpdatesInput;
/**
 * This function validates the outputs to a POST request on /updates
 */
function validatePostUpdatesOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 201) {
        if (!(0, basicValidation_1.validatePostUpdatesResponse201)(response.body)) {
            validatePostUpdatesOutput.errors = basicValidation_1.validatePostUpdatesResponse201.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePostUpdatesOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePostUpdatesOutput = validatePostUpdatesOutput;
/**
 * This function validates the inputs of a GET request on /updates/{device_id}
 */
function validateGetUpdatesByDeviceIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validateGetUpdatesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
        if (parameters["current_version"] &&
            !(0, basicValidation_1.validateCurrentVersion)(parameters["current_version"])) {
            validateGetUpdatesByDeviceIdInput.errors = basicValidation_1.validateCurrentVersion.errors;
            return false;
        }
    }
    return true;
}
exports.validateGetUpdatesByDeviceIdInput = validateGetUpdatesByDeviceIdInput;
/**
 * This function validates the outputs to a GET request on /updates/{device_id}
 */
function validateGetUpdatesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        return true;
    }
    if (response.status === 303) {
        if (response.headers) {
            if (!(0, basicValidation_1.validateGetUpdatesByDeviceIdHeaderLocation)(response.headers["Location"])) {
                validateGetUpdatesByDeviceIdOutput.errors = basicValidation_1.validateGetUpdatesByDeviceIdHeaderLocation.errors;
                return false;
            }
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateGetUpdatesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateGetUpdatesByDeviceIdOutput = validateGetUpdatesByDeviceIdOutput;
/**
 * This function validates the inputs of a PATCH request on /updates/{device_id}
 */
function validatePatchUpdatesByDeviceIdInput(parameters, body) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validatePatchUpdatesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
    }
    if (!(0, basicValidation_1.validatePatchUpdatesByDeviceIdRequestBody)(body)) {
        validatePatchUpdatesByDeviceIdInput.errors = basicValidation_1.validatePatchUpdatesByDeviceIdRequestBody.errors;
        return false;
    }
    return true;
}
exports.validatePatchUpdatesByDeviceIdInput = validatePatchUpdatesByDeviceIdInput;
/**
 * This function validates the outputs to a PATCH request on /updates/{device_id}
 */
function validatePatchUpdatesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 200) {
        if (!(0, basicValidation_1.validatePatchUpdatesByDeviceIdResponse200)(response.body)) {
            validatePatchUpdatesByDeviceIdOutput.errors = basicValidation_1.validatePatchUpdatesByDeviceIdResponse200.errors;
            return false;
        }
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validatePatchUpdatesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validatePatchUpdatesByDeviceIdOutput = validatePatchUpdatesByDeviceIdOutput;
/**
 * This function validates the inputs of a DELETE request on /updates/{device_id}
 */
function validateDeleteUpdatesByDeviceIdInput(parameters) {
    if (parameters) {
        if (!(0, basicValidation_1.validateDeviceId)(parameters["device_id"])) {
            validateDeleteUpdatesByDeviceIdInput.errors = basicValidation_1.validateDeviceId.errors;
            return false;
        }
    }
    return true;
}
exports.validateDeleteUpdatesByDeviceIdInput = validateDeleteUpdatesByDeviceIdInput;
/**
 * This function validates the outputs to a DELETE request on /updates/{device_id}
 */
function validateDeleteUpdatesByDeviceIdOutput(response) {
    if (response.status < 100 || response.status >= 600)
        return false;
    if (response.status === 204) {
        return true;
    }
    if (response.status === 400) {
        return true;
    }
    if (response.status === 401) {
        return true;
    }
    if (response.status === 403) {
        return true;
    }
    if (response.status === 404) {
        return true;
    }
    if (response.status === 500) {
        return true;
    }
    validateDeleteUpdatesByDeviceIdOutput.errors = `Response status ${response.status} is unexpected`;
    return false;
}
exports.validateDeleteUpdatesByDeviceIdOutput = validateDeleteUpdatesByDeviceIdOutput;
//# sourceMappingURL=requestValidation.js.map