"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This file was automatically generated by openapi-codegeneration.
 * DO NOT MODIFY IT BY HAND. Instead, modify the source OpenAPI file,
 * and run openapi-codegeneration to regenerate this file.
 */
const express_1 = __importDefault(require("express"));
const operations = __importStar(require("../operations"));
const types_1 = require("./types");
const requestValidation_1 = require("./requestValidation");
function routes(options = {
    security: {
        JWT: (_req, _scopes) => {
            throw new Error("JWT authentication not implemented");
        },
    },
}) {
    const router = express_1.default.Router();
    async function handleSecurityRequirement(request, securityRequirement) {
        let userData = {};
        for (const method in securityRequirement) {
            userData[method] = await options.security[method](request, securityRequirement[method]);
        }
        return userData;
    }
    router.get("/updates", async (req, res, next) => {
        const security = [
            {
                JWT: ["update", "update:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        try {
            if (!(0, requestValidation_1.validateGetUpdatesInput)()) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetUpdatesInput.errors, 400);
            }
            const result = await operations.getUpdates(userData);
            if (!(0, requestValidation_1.validateGetUpdatesOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetUpdatesOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.post("/updates", async (req, res, next) => {
        const security = [
            {
                JWT: ["update", "update:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePostUpdatesInput)(body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePostUpdatesInput.errors, 400);
            }
            const result = await operations.postUpdates(body, userData);
            if (!(0, requestValidation_1.validatePostUpdatesOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePostUpdatesOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.get("/updates/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["update", "update:list"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
            current_version: req.query["current_version"],
        };
        try {
            if (!(0, requestValidation_1.validateGetUpdatesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateGetUpdatesByDeviceIdInput.errors, 400);
            }
            const result = await operations.getUpdatesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateGetUpdatesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateGetUpdatesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.patch("/updates/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["update", "update:edit"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
        };
        const body = req.body;
        try {
            if (!(0, requestValidation_1.validatePatchUpdatesByDeviceIdInput)(parameters, body)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validatePatchUpdatesByDeviceIdInput.errors, 400);
            }
            const result = await operations.patchUpdatesByDeviceId(parameters, body, userData);
            if (!(0, requestValidation_1.validatePatchUpdatesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validatePatchUpdatesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    router.delete("/updates/:device_id", async (req, res, next) => {
        const security = [
            {
                JWT: ["update", "update:create"],
            },
        ];
        let userData = undefined;
        for (const securityRequirement of security) {
            try {
                userData = await handleSecurityRequirement(req, securityRequirement);
                break;
            }
            catch (error) {
                console.error(error);
                continue;
            }
        }
        if (!userData) {
            next(new Error("Request could not be authenticated"));
            return;
        }
        const parameters = {
            device_id: req.params["device_id"],
        };
        try {
            if (!(0, requestValidation_1.validateDeleteUpdatesByDeviceIdInput)(parameters)) {
                throw new types_1.ValidationError("Request validation failed", requestValidation_1.validateDeleteUpdatesByDeviceIdInput.errors, 400);
            }
            const result = await operations.deleteUpdatesByDeviceId(parameters, userData);
            if (!(0, requestValidation_1.validateDeleteUpdatesByDeviceIdOutput)(result)) {
                throw new types_1.ValidationError("Response validation failed", requestValidation_1.validateDeleteUpdatesByDeviceIdOutput.errors, 500);
            }
            if (result.headers) {
                for (const headerName in result.headers) {
                    const header = result.headers[headerName];
                    if (header) {
                        res.setHeader(headerName, header);
                    }
                }
            }
            return res.status(result.status || 200).send(result.body);
        }
        catch (error) {
            next(error);
            return;
        }
    });
    return router;
}
exports.default = routes;
//# sourceMappingURL=routes.js.map